unit GNOMEPropertyEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DsgnIntf;
type
  TGNOMEAboutEditor = class(TDefaultEditor)
  protected
    procedure EditProperty(PropertyEditor: TPropertyEditor;
      var Continue, FreeEditor: Boolean); override;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TGNOMEAbout=class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

implementation

uses GNOMEAbout;

procedure TGNOMEAboutEditor.EditProperty(PropertyEditor: TPropertyEditor; var Continue, FreeEditor: Boolean);
var
  PropName: string;
begin
  PropName := Uppercase(PropertyEditor.GetName);
  if (CompareText(PropName, 'ABOUT') = 0) then
  begin
    PropertyEditor.Edit;
    Continue := False;
  end;
end;

function TGNOMEAboutEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

function TGNOMEAboutEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then Result := 'About ...' else Result := '';
end;

procedure TGNOMEAboutEditor.ExecuteVerb(Index: Integer);
begin
  if Index = 0 then Edit;
end;

procedure TGNOMEAbout.Edit;
begin
 with TGNOMEAboutForm.Create(Application) do begin
  try
    Refresh;
    ShowModal;
  finally
    Free;
  end;
 end;
end;

function TGNOMEAbout.GetAttributes: TPropertyAttributes;
begin
    Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TGNOMEAbout.GetValue: string;
begin
    Result := 'About GNOME Style';
end;

end.
